import pygame
from lib import FileManager
from Game import Game

#Lo que necesites
from lib.Shadows import *
from lib.CollisionManager import CollisionManager
import lib.PhysicsManager

#Elementos
from fondo import Fondo
from minigames.race.elements.Arcadio import Arcadio
from minigames.race.elements.Enemigo import Enemigo


class Carrera(Game):
    
    def __init__(self, core):
        Game.__init__(self,core)
        self.core = core

        self.fondo = Fondo()
        self.fondo2 = Fondo()
        self.fondo2.initialPosition(0,600) #self.fondo.top+self.fondo.heigth

        
        self.arcadio = Arcadio()
        self.arcadio.mode="run"
        self.enemigo = Enemigo()

        self.end=False

        self.bindSpriteToControls(self.arcadio)
        self.collisions = CollisionManager()


        #FUENTE DE LETRA

        self.core.font.font=pygame.font.SysFont("Arial", 20)
        posx=self.core.screen_width * 0.1
        posy=self.core.screen_height * 0.1
        color=(255,0,0)

        self.info = self.core.font.renderText("Objetivo: Llega antes que el!", posx, posy, color, "left", "top")
        nuevainfo = add_shadow(self.info.getSurface(), (1,1))
        self.info.setSurface(nuevainfo)

        posx2=self.core.screen_width - self.core.screen_width * 0.1
        posy2=self.core.screen_height * 0.1
        color2=(0,255,0)

        self.info2 = self.core.font.renderText("Pulsa A y D!%d B para reintentar", posx2, posy2, color2, "right", "top")
        nuevainfo2 = add_shadow(self.info2.getSurface(), (1,1))
        self.info2.setSurface(nuevainfo2)


        self.infoGanar = self.core.font.renderText("Ganaste!", self.core.screen_width * 0.1, self.core.screen_height * 0.9, (0,0,30), "left", "top")
        self.infoGanar.setSurface(add_shadow(self.infoGanar.getSurface(), (1,1)))

        self.infoPerder = self.core.font.renderText("Perdiste!", self.core.screen_width * 0.1, self.core.screen_height * 0.9, (255,0,0), "left", "top")
        self.infoPerder.setSurface(add_shadow(self.infoPerder.getSurface(), (1,1)))


    def paint(self):

        #Capa 1: FONDO
        self.paintItem(self.fondo)
        self.paintItem(self.fondo2)

        #Capa 2: Bichos
        self.paintItem(self.arcadio)
        self.paintItem(self.enemigo)

        #Capa 3: HUB
        self.paintItem(self.info)
        self.paintItem(self.info2)

        if self.end==True:
            self.paintItem(self.message)



    def logic(self):
        
        self.enemigo.ia()

        #colisionporlados = self.collisions.edgeCollision(self.arcadio, self.enemigo)
        #if len(colisionporlados) > 0:
        #   self.arcadio.colisionado()
    



        if self.getVictory()=="arcadio" and self.end==False:
            self.end=True
            self.message=self.infoGanar

        if self.getVictory()=="enemigo" and self.end==False:
            self.end=True
            self.message=self.infoPerder


        if self.core.controlManager.controlEvents.count(("KEYBUTTON", pygame.K_f)) > 0:
            self.core.toggleFullScreen()


        if self.core.controlManager.controlEvents.count(("KEYBUTTON", pygame.K_b)) > 0:
            self.end=False
            self.arcadio.rect.left=100
            self.enemigo.rect.left=100
            self.message=None
            self.enemigo.movement=1

        

    #METODOS DE APOYO
    def getVictory(self):
        if (self.arcadio.rect.left + self.arcadio.rect.width >= self.core.screen_width * 0.9):
            return "arcadio"

        if (self.enemigo.rect.left + self.enemigo.rect.width >= self.core.screen_width * 0.9):
            return "enemigo"






